<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<link href="common/css/sf.css" rel="stylesheet" type="text/css" />
<title>Postscript: Conclusion and Perspectives</title>
<link href="common/jquery-ui/jquery-ui.css" rel="stylesheet">
<script src="common/jquery-ui/external/jquery/jquery.js"></script>
<script src="common/jquery-ui/jquery-ui.js"></script>
<script src="common/toggleproofs.js"></script>
<link href="common/css/slf.css" rel="stylesheet" type="text/css"/>
</head>

<body>

<div id="page">

<div id="header">
<div id='logoinheader'><a href='https://softwarefoundations.cis.upenn.edu'>
<img src='common/media/image/sf_logo_sm.png' alt='Software Foundations Logo'></a></div>
<div class='booktitleinheader'><a href='index.html'>Volume 6: Separation Logic Foundations</a></div>
<ul id='menu'>
   <li class='section_name'><a href='toc.html'>Table of Contents</a></li>
   <li class='section_name'><a href='coqindex.html'>Index</a></li>
   <li class='section_name'><a href='deps.html'>Roadmap</a></li>
</ul>
</div>

<div id="main">

<h1 class="libtitle">Postscript<span class="subtitle">Conclusion and Perspectives</span></h1>



<div class="doc">
<a id="lab504"></a><h1 class="section">Beyond the Scope of This Course</h1>

<div class="paragraph"> </div>

 This course has focused on the foundations of Separation Logic for
    sequential programs, and discussed the set up of tooling for computing
    weakest preconditions.

<div class="paragraph"> </div>

    There are numerous aspects of Separation Logic that were not covered
    in this course, including:

<div class="paragraph"> </div>

<ul class="doclist">
<li> Concurrent Separation Logic, for reasoning about concurrent behaviors,
      or even, behaviors of weak memory models.

</li>
<li> Automated reasoning using Separation Logic, typically for a restricted
      fragment of Separation Logic.

</li>
<li> Separation Logic for low-level programs, at the byte level, and with
      assembly-style code written in continuation-passing style.

</li>
<li> Separation Logic for object-oriented programs.

</li>
<li> Reasoning about I/O, integer overflows, floatting-point arithmetics,
      etc. 

</li>
</ul>
</div>

<div class="doc">
<a id="lab505"></a><h1 class="section">Historical Notes</h1>

<div class="paragraph"> </div>

 The most relevant historical notes were included near the end of each
    chapter. Additional information may be found in the ICFP'20 paper
    <i>Separation Logic for Sequential Programs</i>, by Arthur Charguéraud.
    <a href='http://www.chargueraud.org/research/2020/seq_seplogic/seq_seplogic.pdf'>http://www.chargueraud.org/research/2020/seq_seplogic/seq_seplogic.pdf</a>
<div class="paragraph"> </div>

 In addition, the reader may be interested in checking out Peter O'Hearn's
    account of the early days of Separation Logic:
    <a href='http://www0.cs.ucl.ac.uk/staff/p.ohearn/SeparationLogic/Separation_Logic/Early_Days.html'>http://www0.cs.ucl.ac.uk/staff/p.ohearn/SeparationLogic/Separation_Logic/Early_Days.html</a>
</div>

<div class="doc">
<a id="lab506"></a><h1 class="section">Tools Leveraging Separation Logic</h1>

<div class="paragraph"> </div>

 Ideas of Separation Logic have had significant influence on the field
    of programming languages from various perspectives. For a broad survey
    of Separation Logic, we refer to Peter O'Hearn's CACM paper <span class="inlinecode">2019</span>.
    <a href='https://dl.acm.org/doi/10.1145/3211968'>https://dl.acm.org/doi/10.1145/3211968</a>
    (Make sure to also download the "supplementary material" link at the bottom
    of the page.)

<div class="paragraph"> </div>

    Here is a non-exhaustive list of active projects leveraging Separation
    Logic.

<div class="paragraph"> </div>

<ul class="doclist">
<li> The tool "Infer" leverages for static analysis, that is, fully automated
      program analysis to produce a list of potential bugs.
      <a href='https://fbinfer.com/'>https://fbinfer.com/</a>
      <a href='https://fbinfer.com/docs/separation-logic-and-bi-abduction/'>https://fbinfer.com/docs/separation-logic-and-bi-abduction/</a>

<div class="paragraph"> </div>


</li>
<li> The programming language "Rust" features a type system with "borrows", a
      notion directly inspired by Separation Logic.

<div class="paragraph"> </div>


</li>
<li> The tool "VeriFast" targets C and Java programs.
      <a href='https://people.cs.kuleuven.be/~bart.jacobs/verifast'>https://people.cs.kuleuven.be/~bart.jacobs/verifast</a> and
      <a href='https://github.com/verifast/verifast'>https://github.com/verifast/verifast</a>

<div class="paragraph"> </div>


</li>
<li> The tool "Verifiable C" tool, from the VST project, targets the
      verification of C code, using interactive Coq proofs based on Separation
      Logic.
      <a href='https://vst.cs.princeton.edu/'>https://vst.cs.princeton.edu/</a>
      See also volume 5 of Software Foundations.

<div class="paragraph"> </div>


</li>
<li> The tool "Viper" is based on a variant of Separation Logic, its front-end
      supports several languages, and its backend leverages the SMT solver Z<sub>3</sub>;
      it also supports user annotations in the code for guiding proofs.
      <a href='https://www.pm.inf.ethz.ch/research/viper.html'>https://www.pm.inf.ethz.ch/research/viper.html</a>

<div class="paragraph"> </div>


</li>
<li> The "Isabelle Refinement Framework" leverages Separation Logic is the
      process of refining monadic high-order logic definitions into efficient
      imperative code. It can be used to produce verified ML code, as well as
      LLVM IR code.
      <a href='https://www21.in.tum.de/~lammich/pub/itp15_sepref.pdf'>https://www21.in.tum.de/~lammich/pub/itp15_sepref.pdf</a>

<div class="paragraph"> </div>


</li>
<li> The tool "CFML", which targets the verification of OCaml programs.
      The original version of CFML leverages a version of characteristic
      formulae slightly more complicated than the one presented in this
      volume. The new version, CFML 2.0, directly leverages all the ideas
      from this course. It is still under active development.

<div class="paragraph"> </div>


</li>
<li> The verified compiler "CakeML" implements technology similar to that
      of CFML, and leverages it to verify components from its standard library
      and from its runtime.

<div class="paragraph"> </div>


</li>
<li> The Iris project develops advanced logics for reasoning about concurrent
      programs using Separation Logic. 

</li>
</ul>
</div>

<div class="doc">
<a id="lab507"></a><h1 class="section">Related Courses</h1>

<div class="paragraph"> </div>

 The following courses focus on reasoning about programs, and should be of
    interest to the reader:

<div class="paragraph"> </div>

<ul class="doclist">
<li> Verifiable C, volume 5 of Sofware Foundations, by Andrew Appel.
      <a href='https://softwarefoundations.cis.upenn.edu/vc-current/index.html'>https://softwarefoundations.cis.upenn.edu/vc-current/index.html</a>

<div class="paragraph"> </div>


</li>
<li> Formal Reasoning About Programs, by Adam Chlipala.
      <a href='http://adam.chlipala.net/frap/'>http://adam.chlipala.net/frap/</a>

<div class="paragraph"> </div>


</li>
<li> The Iris tutorial, by Birkedal and Bizjak, presents the core ideas of
      Iris' concurrent Separation Logic.
      <a href='https://iris-project.org/tutorial-material.html'>https://iris-project.org/tutorial-material.html</a>
</li>
</ul>

<div class="paragraph"> </div>

 Teaser: Arthur Charguéraud has for project to write a follow-up course on
    practical program verification using CFML, focusing on the specification
    and verification of classic data structures and algorithms. 
</div>

<div class="doc">
<a id="lab508"></a><h1 class="section">Acknowledgments</h1>

<div class="paragraph"> </div>

 The lead author of this volume, Arthur Charguéraud, wishes to thank:

<div class="paragraph"> </div>

<ul class="doclist">
<li> Benjamin Pierce, for demonstrating the benefits of Coq-based teaching,
      for coordinating the Software Foundations series, and for encouraging
      me to write this volume.

</li>
<li> The Software Foundations (SF) community, for helping to polish the course
      material and the tooling, and contributing to the success of teaching
      using this material.

</li>
<li> François Pottier, with whom I developed several extensions of Separation
      Logic, and thereby obtained a deeper understanding of this logic.

</li>
<li> Jacques-Henri Jourdan, who introduced me to a number of techniques used
      in the Iris project, and contributed to the definition of <span class="inlinecode"><span class="id" title="var">mkstruct</span></span>.

</li>
<li> Xavier Leroy, with whom I had numerous discussions on mechanized
      semantics.

</li>
<li> Jean-Christophe Filliâtre, for numerous discussions on program
      verification.

</li>
<li> Andrew Appel, Lars Birkedal, Adam Chlipala, Magnus Myreen, Gerwin Klein,
      Peter Lammich, and Zhong Shao, who kindly answered questions on related
      work aspects.

</li>
</ul>

<div class="paragraph"> </div>

   Thanks also to users who contributed feedback and helped fixing typos:
<ul class="doclist">
<li> Jonathan Leivent

</li>
<li> Ori Lahav

</li>
<li> Shachar Itzhaky.

</li>
</ul>

<div class="paragraph"> </div>


</div>
<div class="code">

<span class="comment">(*&nbsp;2023-03-25&nbsp;11:36&nbsp;*)</span><br/>
</div>
</div>

<div id="footer">
<hr/><a href="coqindex.html">Index</a><hr/>This page has been generated by <a href="http://coq.inria.fr/">coqdoc</a>
</div>

</div>

</body>
</html>